// VolTable.h  Copyright 2003  Shunming Fang		1/02/03

#ifndef VOLTABLEH
#define VOLTABLEH

#include <math.h>
#include <stdio.h>
#include "util.h"
#include "EMData.h"

class VolTable
{
    long nx,ny,nz; // basic volume is a nx*ny*nz, this is the size of the volume
    long cx, cy, cz;//store the orgin of image
    long r_; //store the radius
    long nrow; //store how many rows have real data;
    long npixel;//store how many pixels is real pixels 
    long **xmax; // a ny * nz  array of long pointers to start and end of data
    float* rdata; // store real data;

public:
    VolTable();
    ~VolTable();
    void setVolTable(EMData *data_in,long dcx=0,long dcy=0,long dcz=0, long ri = 0);
    void setTableFromMRC(char* fspec,long ri=0);
    void setSize(long x, long y, long z); //sets object size.
    float setRowAndPixel(long ri=0,long dcx=0,long dcy=0,long dcz=0);
    EMData *project3d(float alt,float az,float phi);
    inline long  getXSize() { return nx; }
    inline long  getYSize() { return ny; }
    inline long  getZSize() { return nz; }
    inline long  getCXSize() { return cx; }
    inline long  getCYSize() { return cy; }
    inline long  getCZSize() { return cz; }
    inline float getRadius(){ return r_;}
    inline long getNoOfRow(){ return nrow;}
    inline float* getData(){ return rdata;}
    void zero();	// zero all elements;
    inline long* getPterAt(long n);
    inline long validXYZ(long x, long y, long z);
    inline long validRow(long n);

};

inline long VolTable::validXYZ(long x, long y, long z)
{
    if (y>=ny || y<0 || z>=nz || z<0 || x<xmax[y+z*ny][0] || x>xmax[y+z*ny][1])
	return 0;
    return 1;
}
inline long VolTable::validRow(long n)
{
    if(n<0 || n>nrow)
	return 0;
    return 1;
}
    
inline long* VolTable::getPterAt(long n)
{
    if(!validRow(n))
    {
	return 0;
    }
    return  xmax[n];
}

#endif
